var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));

// node_modules/@girs/gjs/gjs.js
var imports = globalThis.imports || {};
var gjs_default = imports;

// node_modules/@girs/gnome-shell/dist/extensions/extension.js
var extension_exports = {};
__reExport(extension_exports, extension_star);
import * as extension_star from "resource:///org/gnome/shell/extensions/extension.js";

// node_modules/@girs/gio-2.0/gio-2.0.js
import Gio from "gi://Gio?version=2.0";
var gio_2_0_default = Gio;

// node_modules/@girs/glib-2.0/glib-2.0.js
import GLib from "gi://GLib?version=2.0";
var glib_2_0_default = GLib;

// node_modules/@girs/gobject-2.0/gobject-2.0.js
import GObject from "gi://GObject?version=2.0";
var gobject_2_0_default = GObject;

// node_modules/@girs/gst-1.0/gst-1.0.js
import Gst from "gi://Gst?version=1.0";
var gst_1_0_default = Gst;

// node_modules/@girs/st-13/st-13.js
import St from "gi://St?version=13";
var st_13_default = St;

// node_modules/@girs/gnome-shell/dist/ui/main.js
var main_exports = {};
__reExport(main_exports, main_star);
import * as main_star from "resource:///org/gnome/shell/ui/main.js";

// node_modules/@girs/gnome-shell/dist/ui/panelMenu.js
var panelMenu_exports = {};
__reExport(panelMenu_exports, panelMenu_star);
import * as panelMenu_star from "resource:///org/gnome/shell/ui/panelMenu.js";

// node_modules/@girs/gnome-shell/dist/ui/popupMenu.js
var popupMenu_exports = {};
__reExport(popupMenu_exports, popupMenu_star);
import * as popupMenu_star from "resource:///org/gnome/shell/ui/popupMenu.js";

// src/manager.ts
var TManager = class extends gobject_2_0_default.Object {
  sounds;
  loadSounds() {
    const extension = extension_exports.Extension.lookupByUUID("focusli@armonge.info");
    const SOUNDS_BASE_PATH = extension.dir.get_child("sounds").get_path();
    const DB_PATH = glib_2_0_default.build_filenamev([SOUNDS_BASE_PATH, "database.json"]);
    const decoder = new TextDecoder();
    const contents = decoder.decode(glib_2_0_default.file_get_contents(DB_PATH)[1]);
    this.sounds = JSON.parse(contents)["sounds"];
    this.emit("sounds-loaded");
  }
};
var Manager = gobject_2_0_default.registerClass(
  {
    Signals: {
      "sounds-loaded": {}
    }
  },
  TManager
);

// node_modules/@girs/gstaudio-1.0/gstaudio-1.0.js
import GstAudio from "gi://GstAudio?version=1.0";
var gstaudio_1_0_default = GstAudio;

// node_modules/@girs/gnome-shell/dist/ui/slider.js
var slider_exports = {};
__reExport(slider_exports, slider_star);
import * as slider_star from "resource:///org/gnome/shell/ui/slider.js";

// src/sound.ts
var DEFAULT_VOLUME = 0.5;
var TSoundBox = class extends st_13_default.BoxLayout {
  _sensitive;
  _slider;
  _player;
  set sensitive(s) {
    this._sensitive = s;
    this.opacity = s ? 255 : 100;
  }
  get sensitive() {
    return this._sensitive;
  }
  constructor(sound) {
    super({
      style_class: "soundbox flat",
      vertical: true
    });
    let gicon = gio_2_0_default.icon_new_for_string(sound.icon);
    let icon = new st_13_default.Icon({
      style_class: "icon",
      gicon,
      reactive: true
    });
    this.add_child(icon);
    this._slider = new slider_exports.Slider(DEFAULT_VOLUME);
    this._slider.connect("notify::value", this._onSliderChanged.bind(this));
    this.add_child(this._slider);
    this._player = new SoundPlayer(sound);
    icon.connect("button-press-event", this._onButtonPress.bind(this));
  }
  _onButtonPress() {
    if (this.sensitive) {
      this._player.pause();
    } else {
      this._player.play();
    }
    this.sensitive = !this.sensitive;
  }
  _onSliderChanged() {
    const value = this._slider.value;
    this._player.setVolume(value);
    this.sensitive = value > 0;
  }
};
var SoundBox = gobject_2_0_default.registerClass(
  {
    Properties: {
      sensitive: gobject_2_0_default.ParamSpec.boolean(
        "sensitive",
        "Sensitive",
        "Whether the widget is sensitive",
        gobject_2_0_default.ParamFlags.READWRITE | gobject_2_0_default.ParamFlags.CONSTRUCT,
        false
      )
    }
  },
  TSoundBox
);
var SoundPlayer = class {
  prerolled = false;
  playbin;
  sink;
  constructor(sound) {
    this.playbin = gst_1_0_default.ElementFactory.make("playbin", sound.name);
    this.sink = gst_1_0_default.ElementFactory.make("pulsesink", "sink");
    this.playbin.set_property("uri", this.getUri(sound));
    this.playbin.set_property("audio-sink", this.sink);
    let bus = this.playbin.get_bus();
    bus.add_signal_watch();
    bus.connect("message", (_bus, msg) => {
      if (msg != null)
        this._onMessageReceived(msg);
    });
  }
  play() {
    this.playbin.set_state(gst_1_0_default.State.PLAYING);
  }
  pause() {
    this.playbin.set_state(gst_1_0_default.State.PAUSED);
    this.prerolled = false;
  }
  setVolume(value) {
    this.playbin.set_volume(gstaudio_1_0_default.StreamVolumeFormat.LINEAR, value);
    let [_rv, state, _pstate] = this.playbin.get_state(gst_1_0_default.State.NULL);
    if (value == 0) {
      this.playbin.set_state(gst_1_0_default.State.NULL);
    } else if (state != gst_1_0_default.State.PLAYING) {
      this.playbin.set_state(gst_1_0_default.State.PLAYING);
    }
  }
  _onMessageReceived(message) {
    if (message.type == gst_1_0_default.MessageType.SEGMENT_DONE) {
      this.playbin.seek_simple(gst_1_0_default.Format.TIME, gst_1_0_default.SeekFlags.SEGMENT, 0);
    }
    if (message.type == gst_1_0_default.MessageType.ASYNC_DONE) {
      if (!this.prerolled) {
        this.playbin.seek_simple(
          gst_1_0_default.Format.TIME,
          gst_1_0_default.SeekFlags.FLUSH | gst_1_0_default.SeekFlags.SEGMENT,
          0
        );
        this.prerolled = true;
      }
    }
    return true;
  }
  getUri(sound) {
    return gst_1_0_default.filename_to_uri(sound.uri);
  }
};
;

// src/extension.ts
gst_1_0_default.init(null);
var TPopup = class extends popupMenu_exports.PopupBaseMenuItem {
  manager;
  box;
  constructor() {
    super({
      reactive: false,
      can_focus: false
    });
    this.box = new st_13_default.BoxLayout({
      vertical: true
    });
    this.add_child(this.box);
    this.manager = new Manager();
    this.manager.connect("sounds-loaded", () => {
      this._onSoundsReady();
    });
    this.manager.loadSounds();
  }
  _onSoundsReady() {
    let sounds = this.manager.sounds;
    for (let idx = 0; idx < sounds.length; idx += 2) {
      let sound_box1 = new SoundBox(sounds[idx]);
      let line = new st_13_default.BoxLayout();
      line.add_child(sound_box1);
      if (sounds[idx + 1]) {
        let sound_box2 = new SoundBox(sounds[idx + 1]);
        line.add_child(sound_box2);
      }
      this.box.add_child(line);
    }
  }
};
var Popup = gobject_2_0_default.registerClass(TPopup);
var TButton = class extends panelMenu_exports.Button {
  constructor() {
    super(0, "Focusli");
    const extension = extension_exports.Extension.lookupByUUID("focusli@armonge.info");
    let box = new st_13_default.BoxLayout({
      style_class: "panel-status-menu-box"
    });
    let icon_path = glib_2_0_default.build_filenamev([
      extension.dir.get_path(),
      "icon.png"
    ]);
    let gicon = gio_2_0_default.Icon.new_for_string(icon_path);
    let icon = new st_13_default.Icon({
      gicon,
      style_class: "system-status-icon"
    });
    box.add_child(icon);
    this.add_child(box);
    let popup = new Popup();
    this.menu.addMenuItem(popup);
  }
};
var Button = gobject_2_0_default.registerClass(TButton);
var FocusliExtension = class extends extension_exports.Extension {
  button;
  constructor(metadata) {
    super(metadata);
    console.debug(`constructing ${this.metadata.name}`);
  }
  enable() {
    console.debug(`enabling ${this.metadata.name}`);
    this.button = new Button();
    main_exports.panel.addToStatusArea("focusli", this.button);
    console.debug(`enabled test ${this.metadata.name}`);
  }
  disable() {
    console.debug(`disabling ${this.metadata.name}`);
    this.button.destroy();
  }
};
export {
  FocusliExtension as default
};
